gCameraX = 0
gCameraY = 0
gCameraSStart = 0.25
gCameraS = gCameraSStart


function world2ScreenPosition(x,y)
	return (x - gCameraX) * gCameraS, (y - gCameraY) * gCameraS
end

function intervalOverlap(a0, a1, b0, b1)
	if b0 >= a0 then
		if b0 <= a1 then
			return true
		else
			return false
		end
 	else
		if b1 >= a0 then
			return true
		else
			return false
		end
	end
end

function camWorldSize()
	return gScreenW / gCameraS, gScreenH / gCameraS
end

function ensurePointIsVisible(x,y, borderInPx)
	local b = borderInPx / gCameraS
	local w,h = camWorldSize()
	local dx,dy = distPointAABB(x,y,
		gCameraX+b,gCameraY+b,
		gCameraX+w-b,gCameraY+h-b)
	gCameraX = gCameraX - dx
	gCameraY = gCameraY - dy
end

function distPointAABB(x,y,x1,y1,x2,y2)
	local dx,dy = 0,0
	
	if x < x1 then dx = x1 - x
	elseif x > x2 then dx = x2 - x
	end
	
	if y < y1 then dy = y1 - y
	elseif y > y2 then dy = y2 - y
	end
	
	return dx,dy
end
