
Timer = Object{
	_init = {"dt"},
	_last_tick = nil,
	tick = function(self) end,
	update = function(self)
		if self._last_tick == nil then 
			self._last_tick = love.timer.getTime() * 1000
		else
			local now = love.timer.getTime() * 1000
			local dt = self.dt
			local last = self._last_tick
			while now - last >= dt do
				self:tick()
				last = last + dt
			end
			self._last_tick = last
		end
	end,
}
