gTileW = 100
gTileH = 100

function tile2WorldPosition(tileX,tileY)
	return tileX * gTileW, tileY * gTileH
end


function drawTile(image, tileX, tileY)
	drawImage(image, tile2WorldPosition(tileX, tileY))
end


function getImage(filename)
	return love.graphics.newImage("gfx/" .. filename)
end


function drawAnim(anim, x, y)
	local lx,ly = world2ScreenPosition(x,y)
	anim:draw(lx,ly, 0, gCameraS, gCameraS)
end

function drawImage(image, x, y)
	local lx,ly = world2ScreenPosition(x,y)
	love.graphics.draw(image, lx,ly, 0, gCameraS, gCameraS)
end
