events = {}
function registerEvent(name, fun)
	events[name] = events[name] or {}
	table.insert(events[name], fun)
end

function triggerEvent(name, ...)
	if events[name] then
		for k,v in pairs(events[name]) do
			local r = v(...)
			if r == true then
				print("remove event", name, v)
				events[name][k] = nil
			end
		end
	end
end

