gGfxPath = "gfx/"
gSoundPath = "sound/"

gSound_Sand = love.audio.newSound( gSoundPath .. "sand.ogg" )
gSound_Diamond = love.audio.newSound( gSoundPath .. "diamond.ogg" )
gSound_Slime = love.audio.newSound( gSoundPath .. "slime.ogg" )
gSound_CrashMonster = love.audio.newSound( gSoundPath .. "crashmonster.ogg" )
gSound_CrashHuman = love.audio.newSound( gSoundPath .. "ohoh.ogg" )
gSound_StoneHitGround = love.audio.newSound( gSoundPath .. "stonehitground.ogg" )
gSound_Collect = love.audio.newSound( gSoundPath .. "collect.ogg" )
gSound_ExtraLife = love.audio.newSound( gSoundPath .. "jupii.ogg" )
gSound_AllCollected = love.audio.newSound( gSoundPath .. "juhu.ogg" )
gSound_LevelFinished = love.audio.newSound( gSoundPath .. "dodododoooo.ogg" )
gSound_Move = love.audio.newSound( gSoundPath .. "move.ogg" )

gAnimation_Diamond = newAnimation(love.graphics.newImage(gGfxPath .. "diamantbewegt.png"),100,100,0.2,0)
gAnimation_Monster = newAnimation(love.graphics.newImage(gGfxPath .. "monsterbewegt.png"),100,100,0.2,0)
gAnimation_Slime = newAnimation(love.graphics.newImage(gGfxPath .. "schleimbewegt.png"),100,100,0.5,0)
gAnimation_DoorOpened = newAnimation(love.graphics.newImage(gGfxPath .. "tueroffenbewegt.png"),100,100,0.5,0)
gAnimation_Leben = newAnimation(love.graphics.newImage(gGfxPath .. "lebenanim.png"),100,100,0.2,0)

gBackgroundGfx = love.graphics.newImage(gGfxPath .. "hintergrund.png")

gImage_Title = love.graphics.newImage(gGfxPath .. "title.png")
gImage_Menu = love.graphics.newImage(gGfxPath .. "menu.png")
gImage_Credits = love.graphics.newImage(gGfxPath .. "credits.png")
gImage_Finished = love.graphics.newImage(gGfxPath .. "finish.png")
gImage_GameOver = love.graphics.newImage(gGfxPath .. "gameover.png")

gImage_MenuItems_Off = {
	love.graphics.newImage(gGfxPath .. "menu_item_newgame_off.png"),
	love.graphics.newImage(gGfxPath .. "menu_item_credits_off.png"),
	love.graphics.newImage(gGfxPath .. "menu_item_exit_off.png"),
}

gImage_MenuItems_On = {
	love.graphics.newImage(gGfxPath .. "menu_item_newgame_on.png"),
	love.graphics.newImage(gGfxPath .. "menu_item_credits_on.png"),
	love.graphics.newImage(gGfxPath .. "menu_item_exit_on.png"),
}